<?php
if (!defined('FUNC_FILE')) die("Illegal File Access");

// PHP Version
$phpver = phpversion();
if ($phpver < '4.1.0') {
	$_GET = $HTTP_GET_VARS;
	$_POST = $HTTP_POST_VARS;
	$_COOKIE = $HTTP_COOKIE_VARS;
	$_REQUEST = array_merge($_GET, $_POST, $_COOKIE);
	$_FILES = $HTTP_POST_FILES;
	$_SERVER = $HTTP_SERVER_VARS;
}
$phpver = explode(".", $phpver);
$phpver = "$phpver[0]$phpver[1]";
if ($phpver >= 41) {
	$PHP_SELF = $_SERVER['PHP_SELF'];
}

// Quotes filter
function FixQuotes($what = "") {
	$what = ereg_replace("'","''",$what);
    while (eregi("\\\\'", $what)) {
        $what = ereg_replace("\\\\'","'",$what);
    }
    return $what;
}

// Quotes delete
function delQuotes($string) {
    $tmp = "";
	$result = "";
	$i = 0;
    $attrib = -1;
    $quote = 0;
	$len = strlen($string);
	while ($i<$len) {
        switch($string[$i]) {
			case "\"":
			if ($quote == 0) {
				$quote = 1;
			} else {
				$quote = 0;
				if (($attrib > 0) && ($tmp != "")) {
					$result .= "=\"$tmp\"";
				}
				$tmp = "";
				$attrib = -1;
			}
			break;
            case "=":
			if ($quote == 0) {
				$attrib = 1;
				if ($tmp != "") {
					$result .= " $tmp";
				}
				$tmp = "";
			} else {
				$tmp .= '=';
			}
			break;
			case " ":
			if ($attrib > 0) {
				$tmp .= $string[$i];
			}
			break;
            default:
			if ($attrib < 0) {
				$attrib = 0;
			}
			$tmp .= $string[$i];
			break;
		}
		$i++;
	}
    if (($quote!=0) && ($tmp != "")) {
		if ($attrib == 1) {
			$result .= "=";
		}
		$result .= "\"$tmp\"";
	}
	return $result;
}

// Word censor filter
function check_words($Message) {
	global $CensorMode, $CensorReplace, $EditedMessage, $CensorList;
    $EditedMessage = $Message;
	if ($CensorMode) {
		$CensorList = explode(",", $CensorList);
		foreach ($CensorList as $key => $val) $EditedMessage = preg_replace("/$val/i", $CensorReplace, $EditedMessage);
	}
	return $EditedMessage;
}

// HTML check filter
function check_html($str, $strip="") {
	$AllowableHTML = array("b"=>1, "i"=>1, "s"=>1, "div"=>2, "u"=>1, "a"=>2, "em"=>1, "br"=>1, "strong"=>1, "tt"=>1, "li"=>1, "ol"=>1, "ul"=>1);
    if ($strip == "nohtml") $AllowableHTML = array('');
	$str = stripslashes($str);
	$str = eregi_replace("<[[:space:]]*([^>]*)[[:space:]]*>",'<\\1>', $str);
	$str = eregi_replace("<a[^>]*href[[:space:]]*=[[:space:]]*\"?[[:space:]]*([^\" >]*)[[:space:]]*\"?[^>]*>",'<a href="\\1">', $str);
	$str = eregi_replace("<[[:space:]]* img[[:space:]]*([^>]*)[[:space:]]*>", '', $str);
	$str = eregi_replace("<a[^>]*href[[:space:]]*=[[:space:]]*\"?javascript[[:punct:]]*\"?[^>]*>", '', $str);
	$tmp = "";
	while (ereg("<(/?[[:alpha:]]*)[[:space:]]*([^>]*)>",$str,$reg)) {
		$i = strpos($str,$reg[0]);
		$l = strlen($reg[0]);
		if ($reg[1][0] == "/") {
			$tag = strtolower(substr($reg[1],1));
		} else {
			$tag = strtolower($reg[1]);
		}
		if ($a = $AllowableHTML[$tag]) {
			if ($reg[1][0] == "/") {
				$tag = "</$tag>";
			} elseif (($a == 1) || ($reg[2] == "")) {
				$tag = "<$tag>";
			} else {
				$attrb_list = delQuotes($reg[2]);
				$attrb_list = ereg_replace("&","&amp;",$attrb_list);
				$tag = "<$tag" . $attrb_list . ">";
			}
		} else {
			$tag = "";
		}
		$tmp .= substr($str,0,$i) . $tag;
		$str = substr($str,$i+$l);
	}
	$str = $tmp . $str;
	return $str;
	exit;
	$str = ereg_replace("<\?","",$str);
	return $str;
}

// Text filter, check HTML and Word filter
function filter_text($Message, $strip="") {
    global $EditedMessage;
    check_words($Message);
    $EditedMessage = check_html($EditedMessage, $strip);
    return $EditedMessage;
}

// Format image key
switch(isset($_REQUEST['gfx'])) {
	case "gfx":
	$code = substr(hexdec(md5("".date("F j")."".$_REQUEST["random_num"]."".$sitekey."")), 2, 6);
    $image = ImageCreateFromJpeg("images/code_bg.jpg");
    $text_color = ImageColorAllocate($image, 100, 100, 100);
    Header("Content-type: image/jpeg");
    ImageString($image, 5, 12, 2, $code, $text_color);
    ImageJpeg($image, "", 50);
    ImageDestroy($image);
    exit;
    break;
}
?>