<?php
if (!defined("SETUP_FILE")) die("Illegal File Access");
define("DB", true);
define("FUNC_FILE", true);
error_reporting(0);
if (!ini_get("register_globals")) import_request_variables('GPC');

if (isset($_COOKIE["lang"])) {
	include("setup/language/lang-".$_COOKIE["lang"].".php");
} else {
	include("setup/language/lang-english.php");
}

function head() {
	global $title;
	echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n"
	."<html>\n"
	."<head>\n"
	."<meta http-equiv=\"content-type\" content=\"text/html; charset="._CHARSET."\">\n"
	."<title>"._SETUP_SLAED_SMC."</title>\n"
	."<link rel=\"stylesheet\" href=\"templates/Stability/style.css\" type=\"text/css\">\n"
	."</head>\n"
	."<body>\n"
	."<br><br><br><table width=\"60%\" align=\"center\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">"
	."<tr><td align=\"center\"><img src=\"images/logos/logo.gif\" border=\"0\" title=\"SLAED CMS\"></td></tr><tr><td align=\"center\"><br><br><br><font class=\"option\">$title</font><br><br></td></tr><tr><td>\n";
}

function foot() {
	echo "</td></tr></table>\n"
	."</body>\n"
	."</html>";
}

function language() {
	global $title;
	$title = (phpversion() < "4.3.0") ? ""._PHPSETUP."" : ""._LANG."";
	head();
	echo "<table align=\"center\" border=\"0\" cellspacing=\"0\" cellpadding=\"5\"><tr>"
	."<td><a href=\"setup.php?op=english\" title=\"English\"><img src=\"images/language/flag-english.gif\" border=\"0\"></a></td><td><a href=\"setup.php?op=english\" title=\"English\">English</a></td>"
	."<td><a href=\"setup.php?op=german\" title=\"German\"><img src=\"images/language/flag-german.gif\" border=\"0\"></a></td><td><a href=\"setup.php?op=german\" title=\"German\">German</a></td>"
	."<td><a href=\"setup.php?op=russian\" title=\"Russian\"><img src=\"images/language/flag-russian.gif\" border=\"0\"></a></td><td><a href=\"setup.php?op=russian\" title=\"Russian\">Russian</a></td>"
	."</tr>";
	if (isset($_GET["lang"]) && $_GET["lang"] == 1) {
		echo "<tr><td align=\"center\" colspan=\"6\"><br><br><form action=\"setup.php\" method=\"post\">"
		."<input type=\"hidden\" name=\"op\" value=\"license\">"
		."<input type=\"submit\" value=\""._NEXT."\"></td></tr>";
	}
	echo "</table>";
	foot();
}

function license() {
	global $title;
	$title = ""._LICENSE."";
	head();
	if (isset($_COOKIE["lang"])) {
		$bodytext = file_get_contents("setup/doc/lang-".$_COOKIE["lang"].".txt");
	} else {
		$bodytext = file_get_contents("setup/doc/lang-english.txt");
	}
	echo "<table align=\"center\" border=\"0\" cellspacing=\"0\" cellpadding=\"3\">"
	."<tr><td><textarea cols=\"45\" rows=\"15\" style=\"width:400px\">$bodytext</textarea></td></tr>"
	."<tr><td><form action=\"setup.php\" method=\"post\"><input type=\"checkbox\" name=\"license_check\" value=\"1\">"._LICENSE_OK."</td></tr>"
	."<tr><td align=\"center\"><br><br>"._GOBACK." <input type=\"hidden\" name=\"op\" value=\"config\">"
	."<input type=\"submit\" value=\""._NEXT."\"></td></tr>"
	."</table>";
	foot();
}

function config() {
	global $title;
	$title = ""._CONFIG."";
	if (file_exists('config/config.php')) {
		@chmod('config/config.php', 0666);
		$permsdir = decoct(fileperms("config/config.php"));
		$perms = substr("$permsdir",-3);
		if ($perms != "666") {
			$title = ""._FILE." config/config.php "._ERRORPERM." CHMOD - 666";
			head();
			foot();
			exit;
		}
	}
	if (file_exists('config/config_global.php')) {
		@chmod('config/config_global.php', 0666);
		$permsdir = decoct(fileperms("config/config_global.php"));
		$perms = substr("$permsdir",-3);
		if ($perms != "666") {
			$title = ""._FILE." config/config_global.php "._ERRORPERM." CHMOD - 666";
			head();
			foot();
			exit;
		}
	}
	head();
	if ($_POST["license_check"] == "1") {
		echo "<table align=\"center\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">"
		."<form action=\"setup.php\" method=\"post\">"
		."<tr><td><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"3\">"
		."<tr><td>"._SETUP_NEW.":</td><td align=\"right\"><input type=\"radio\" name=\"setup\" value=\"new\" checked></td></tr>"
		."<tr><td>"._UPDATE." 1.4 > 1.5:</td><td align=\"right\"><input type=\"radio\" name=\"setup\" value=\"update1_5\"></td></tr>"
		."<tr><td>"._UPDATE." 1.5 > 1.6 Free:</td><td align=\"right\"><input type=\"radio\" name=\"setup\" value=\"update1_6\"></td></tr>"
		."<tr><td>"._UPDATE." 2.0 Lite > 2.1 Lite:</td><td align=\"right\"><input type=\"radio\" name=\"setup\" value=\"update2_1\"></td></tr>"
		."<tr><td>"._UPDATE." 2.1 Lite > 2.2 Lite:</td><td align=\"right\"><input type=\"radio\" name=\"setup\" value=\"update2_2\"></td></tr>"
		."<tr><td>"._UPDATE." 2.2 Lite > 2.3 Lite:</td><td align=\"right\"><input type=\"radio\" name=\"setup\" value=\"update2_3\"></td></tr>"
		."<tr><td>"._UPDATE." 2.3 Lite > 2.4 Lite:</td><td align=\"right\"><input type=\"radio\" name=\"setup\" value=\"update2_4\"></td></tr>"
		."<tr><td colspan=\"2\"><hr></td></tr>"
		."</table></td></tr>"
		."<tr><td><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"3\">"
		."<tr><td>"._CONF_1.":</td><td align=\"right\"><input type=\"text\" name=\"xdbhost\" value=\"localhost\" size=\"25\"></td></tr>"
		."<tr><td>"._CONF_2.":</td><td align=\"right\"><input type=\"text\" name=\"xdbuname\" value=\"root\" size=\"25\"></td></tr>"
		."<tr><td>"._CONF_3.":</td><td align=\"right\"><input type=\"text\" name=\"xdbpass\" size=\"25\"></td></tr>"
		."<tr><td>"._CONF_4.":</td><td align=\"right\"><input type=\"text\" name=\"xdbname\" size=\"25\"></td></tr>"
		."<tr><td colspan=\"2\"><hr></td></tr>"
		."</table></td></tr>"
		."<tr><td><table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"3\">"
		."<tr><td>"._CONF_5.":</td><td align=\"right\"><input type=\"text\" name=\"xadmin_file\" value=\"admin\" size=\"25\"></td></tr>"
		."<tr><td>"._CONF_7.":</td><td align=\"right\"><input type=\"text\" name=\"xprefix\" value=\"slaed\" size=\"25\"></td></tr>"
		."<tr><td align=\"center\" colspan=\"2\"><br><br>"._GOBACK." <input type=\"hidden\" name=\"op\" value=\"save\">"
		."<input type=\"submit\" value=\""._NEXT."\"></td></tr>"
		."</table></td></tr>";
		echo "</table>";
	} else {
		Header("Location: setup.php?op=license");
	}
	foot();
}

function save($setup, $xdbhost, $xdbuname, $xdbpass, $xdbname, $xadmin_file, $xprefix) {
	global $title;
	require_once("config/config_global.php");
	$bodytext = "";
	$conectionid = @mysql_connect($xdbhost, $xdbuname, $xdbpass);
	if ($conectionid) {
		$db = @mysql_select_db($xdbname);
		if (!$db) {
			$title = ""._ERROR."";
			head();
			echo "<br><br><center>"._GOBACK."</center>";
			foot();
			exit;
		}
		if ($setup == "new") {
			$title = ""._SAVE_NEW."";
			$filename = "setup/sql/table.sql";
			$readdump = fopen($filename, "r");
			$stringdump = fread($readdump, filesize($filename));
			fclose($readdump);
			$stringdump = split(";",$stringdump);
			$dump_count = count($stringdump);
			for ($i = 0; $i < $dump_count; $i++) {
				$string = str_replace("{pref}", $xprefix, $stringdump[$i]);
				$id = mysql_query($string);
				if (eregi("CREATE", $string)) {
					$table = explode("`", $string);
					$bodytext .= "<tr><td>"._TABLE.":</td><td>".$table[1]." ".(($id) ? "</td><td><font color=\"green\">"._OK."</font></td>" : "<td><font color=\"red\">"._ALERT."</font></td>")."</tr>";
				}
			}
			$filename = "setup/sql/insert.sql";
			$readdump = fopen($filename, "r");
			$stringdump = fread($readdump, filesize($filename));
			fclose($readdump);
			$stringdump = split(";",$stringdump);
			$dump_count = count($stringdump);
			for ($i = 0; $i < $dump_count; $i++) {
				$string = str_replace("{pref}", $xprefix, $stringdump[$i]);
				$id2 = mysql_query($string);
				if (eregi("CREATE", $string)) {
					$table = explode("`", $string);
					$bodytext .= "<tr><td>"._TABLE.":</td><td>".$table[1]." ".(($id2) ? "</td><td><font color=\"green\">"._OK."</font></td>" : "<td><font color=\"red\">"._ALERT."</font></td>")."</tr>";
				}
			}
		} elseif ($setup == "update1_5") {
			$title = ""._SAVE_UPDATE."";
			$filename = "setup/sql/table_update1_5.sql";
			$readdump = fopen($filename, "r");
			$stringdump = fread($readdump, filesize($filename));
			fclose($readdump);
			$stringdump = split(";",$stringdump);
			$dump_count = count($stringdump);
			for ($i = 0; $i < $dump_count; $i++) {
				$string = str_replace("{pref}", $xprefix, $stringdump[$i]);
				$id = mysql_query($string);
				if (eregi("CREATE|ALTER|DELETE|DROP|UPDATE", $string)) {
					$table = explode("`", $string);
					$bodytext .= "<tr><td>"._TABLE.":</td><td>".$table[1]." ".(($id) ? "</td><td><font color=\"green\">"._OK."</font></td>" : "<td><font color=\"red\">"._ALERT."</font></td>")."</tr>";
				}
			}
		} elseif ($setup == "update1_6") {
			$title = ""._SAVE_UPDATE."";
			$filename = "setup/sql/table_update1_6.sql";
			$readdump = fopen($filename, "r");
			$stringdump = fread($readdump, filesize($filename));
			fclose($readdump);
			$stringdump = split(";",$stringdump);
			$dump_count = count($stringdump);
			for ($i = 0; $i < $dump_count; $i++) {
				$string = str_replace("{pref}", $xprefix, $stringdump[$i]);
				$id = mysql_query($string);
				if (eregi("CREATE|ALTER|DELETE|DROP|UPDATE", $string)) {
					$table = explode("`", $string);
					$bodytext .= "<tr><td>"._TABLE.":</td><td>".$table[1]." ".(($id) ? "</td><td><font color=\"green\">"._OK."</font></td>" : "<td><font color=\"red\">"._ALERT."</font></td>")."</tr>";
				}
			}
		} elseif ($setup == "update2_0") {
			$title = ""._SAVE_UPDATE."";
			$filename = "setup/sql/table_update2_0.sql";
			$readdump = fopen($filename, "r");
			$stringdump = fread($readdump, filesize($filename));
			fclose($readdump);
			$stringdump = split(";",$stringdump);
			$dump_count = count($stringdump);
			for ($i = 0; $i < $dump_count; $i++) {
				$string = str_replace("{pref}", $xprefix, $stringdump[$i]);
				$id = mysql_query($string);
				if (eregi("CREATE|ALTER|DELETE|DROP|UPDATE", $string)) {
					$table = explode("`", $string);
					$bodytext .= "<tr><td>"._TABLE.":</td><td>".$table[1]." ".(($id) ? "</td><td><font color=\"green\">"._OK."</font></td>" : "<td><font color=\"red\">"._ALERT."</font></td>")."</tr>";
				}
			}
			$result = mysql_query("SELECT lid, date, name, email, url, host_name, comment FROM ".$xprefix."_files_comments");
			while (list($lid, $date, $name, $email, $url, $host_name, $comment) = @mysql_fetch_array($result)) {
				mysql_query("INSERT INTO ".$xprefix."_comment (id, cid, modul, date, name, url, email, icq, aim, yim, msn, host_name, comment) VALUES (NULL, '$lid', 'Files', '$date', '$name', '$url', '$email', '', '', '', '', '$host_name', '$comment')");
			}
			if (!$result) {
				$result_text = "<font color=\"red\">"._ALERT."</font>";
			} else {
				$result_text = "<font color=\"green\">"._OK."</font>";
				mysql_query("DROP TABLE ".$xprefix."_files_comments");
			}
			$bodytext .= "<tr><td>"._TABLE.":</td><td>".$xprefix."_files_comments > ".$xprefix."_comment</td><td>$result_text</td></tr>";
			$result = mysql_query("SELECT lid, date, name, email, url, host_name, comment FROM ".$xprefix."_links_comments");
			while (list($lid, $date, $name, $email, $url, $host_name, $comment) = @mysql_fetch_array($result)) {
				mysql_query("INSERT INTO ".$xprefix."_comment (id, cid, modul, date, name, url, email, icq, aim, yim, msn, host_name, comment) VALUES (NULL, '$lid', 'Links', '$date', '$name', '$url', '$email', '', '', '', '', '$host_name', '$comment')");
			}
			if (!$result) {
				$result_text = "<font color=\"red\">"._ALERT."</font>";
			} else {
				$result_text = "<font color=\"green\">"._OK."</font>";
				mysql_query("DROP TABLE ".$xprefix."_links_comments");
			}
			$bodytext .= "<tr><td>"._TABLE.":</td><td>".$xprefix."_links_comments > ".$xprefix."_comment</td><td>$result_text</td></tr>";
			$result = mysql_query("SELECT poll_id, date, name, email, url, host_name, comment FROM ".$xprefix."_survey_comments");
			while (list($poll_id, $date, $name, $email, $url, $host_name, $comment) = @mysql_fetch_array($result)) {
				mysql_query("INSERT INTO ".$xprefix."_comment (id, cid, modul, date, name, url, email, icq, aim, yim, msn, host_name, comment) VALUES (NULL, '$poll_id', 'Voting', '$date', '$name', '$url', '$email', '', '', '', '', '$host_name', '$comment')");
			}
			if (!$result) {
				$result_text = "<font color=\"red\">"._ALERT."</font>";
			} else {
				$result_text = "<font color=\"green\">"._OK."</font>";
				mysql_query("DROP TABLE ".$xprefix."_survey_comments");
			}
			$bodytext .= "<tr><td>"._TABLE.":</td><td>".$xprefix."_survey_comments > ".$xprefix."_comment</td><td>$result_text</td></tr>";
			$result = mysql_query("SELECT sid, date, name, email, url, host_name, comment FROM ".$xprefix."_comments");
			while (list($sid, $date, $name, $email, $url, $host_name, $comment) = @mysql_fetch_array($result)) {
				mysql_query("INSERT INTO ".$xprefix."_comment (id, cid, modul, date, name, url, email, icq, aim, yim, msn, host_name, comment) VALUES (NULL, '$sid', 'News', '$date', '$name', '$url', '$email', '', '', '', '', '$host_name', '$comment')");
			}
			if (!$result) {
				$result_text = "<font color=\"red\">"._ALERT."</font>";
			} else {
				$result_text = "<font color=\"green\">"._OK."</font>";
				mysql_query("DROP TABLE ".$xprefix."_comments");
			}
			$bodytext .= "<tr><td>"._TABLE.":</td><td>".$xprefix."_comments > ".$xprefix."_comment</td><td>$result_text</td></tr>";
		} elseif ($setup == "update2_1") {
			$title = ""._SAVE_UPDATE."";
			$result = mysql_query("SELECT user_id, user_regdate FROM ".$xprefix."_users");
			while (list($user_id, $user_regdate) = @mysql_fetch_array($result)) {
				$user_regdate = gmdate('Y-m-d', strtotime("+1 day", strtotime($user_regdate)));
				mysql_query("UPDATE ".$xprefix."_users SET user_regdate='$user_regdate' WHERE user_id='$user_id'");
			}
			if (!$result && !$result2) {
				$result_text = "<font color=\"red\">"._ALERT."</font>";
			} else {
				$result_text = "<font color=\"green\">"._OK."</font>";
			}
			$bodytext .= "<tr><td>"._TABLE.":</td><td>".$xprefix."_users</td><td>$result_text</td></tr>";
			$filename = "setup/sql/table_update2_1.sql";
			$readdump = fopen($filename, "r");
			$stringdump = fread($readdump, filesize($filename));
			fclose($readdump);
			$stringdump = split(";",$stringdump);
			$dump_count = count($stringdump);
			for ($i = 0; $i <= $dump_count; $i++) {
				$string = str_replace("{pref}", $xprefix, $stringdump[$i]);
				$id = mysql_query($string);
				if (eregi("CREATE|ALTER|DELETE|DROP|UPDATE", $string)) {
					$table = explode("`", $string);
					$bodytext .= "<tr><td>"._TABLE.":</td><td>".$table[1]." ".(($id) ? "</td><td><font color=\"green\">"._OK."</font></td>" : "<td><font color=\"red\">"._ALERT."</font></td>")."</tr>";
				}
			}
		} elseif ($setup == "update2_2") {
			$title = ""._SAVE_UPDATE."";
			$filename = "setup/sql/table_update2_2.sql";
			$readdump = fopen($filename, "r");
			$stringdump = fread($readdump, filesize($filename));
			fclose($readdump);
			$stringdump = split(";",$stringdump);
			$dump_count = count($stringdump);
			for ($i = 0; $i <= $dump_count; $i++) {
				$string = str_replace("{pref}", $xprefix, $stringdump[$i]);
				$id = mysql_query($string);
				if (eregi("CREATE|ALTER|DELETE|DROP|UPDATE", $string)) {
					$table = explode("`", $string);
					$bodytext .= "<tr><td>"._TABLE.":</td><td>".$table[1]." ".(($id) ? "</td><td><font color=\"green\">"._OK."</font></td>" : "<td><font color=\"red\">"._ALERT."</font></td>")."</tr>";
				}
			}
			$result = mysql_query("SELECT name FROM ".$xprefix."_comment");
			while (list($name) = mysql_fetch_array($result)) {
				list($id) = mysql_fetch_array(mysql_query("SELECT user_id FROM ".$xprefix."_users WHERE user_name='$name'"));
				if (intval($id)) mysql_query("UPDATE ".$xprefix."_comment SET uid='$id' WHERE name='$name'");
			}
			if (!$result) {
				$result_text = "<font color=\"red\">"._ALERT."</font>";
			} else {
				$result_text = "<font color=\"green\">"._OK."</font>";
			}
			$bodytext .= "<tr><td>"._TABLE.":</td><td>".$xprefix."_comment</td><td>$result_text</td></tr>";
		} elseif ($setup == "update2_4") {
			$title = ""._SAVE_UPDATE."";
			$filename = "setup/sql/table_update2_4.sql";
			$readdump = fopen($filename, "r");
			$stringdump = fread($readdump, filesize($filename));
			fclose($readdump);
			$stringdump = split(";",$stringdump);
			$dump_count = count($stringdump);
			for ($i = 0; $i < $dump_count; $i++) {
				$string = str_replace("{pref}", $xprefix, $stringdump[$i]);
				$id = mysql_query($string);
				if (eregi("CREATE|ALTER|DELETE|DROP|UPDATE", $string)) {
					$table = explode("`", $string);
					$bodytext .= "<tr><td>"._TABLE.":</td><td>".$table[1]." ".(($id) ? "</td><td><font color=\"green\">"._OK."</font></td>" : "<td><font color=\"red\">"._ALERT."</font></td>")."</tr>";
				}
			}
		}
		mysql_close($conectionid);
		
		@include("config/config.php");
		$temp_file = (isset($admin_file)) ? $admin_file : "admin";
			
		$fp = fopen("config/config.php", "wb");
		$content = "<?php\n";
		$content .= "if (!defined(\"DB\")) die(\"Illegal File Access\");\n";
		$content .= "\n";
		$content .= "\$dbhost = \"$xdbhost\";\n";
		$content .= "\$dbuname = \"$xdbuname\";\n";
		$content .= "\$dbpass = \"$xdbpass\";\n";
		$content .= "\$dbname = \"$xdbname\";\n";
		$content .= "\n";
		$content .= "\$admin_file = \"$xadmin_file\";\n";
		$content .= "\$prefix = \"$xprefix\";\n";
		$content .= "\n";
		$content .= "?>";
		fwrite($fp, $content);
		fclose($fp);
			
		@include("config/config_global.php");
		$content = file_get_contents('config/config_global.php');
		if (isset($_COOKIE["lang"])) $content = str_replace('$language = "'.$language.'";', '$language = "'.$_COOKIE["lang"].'";', $content);
		$content = str_replace('$homeurl = "'.$homeurl.'";', '$homeurl = "http://'.$_SERVER["SERVER_NAME"].'";', $content);
		$fp = fopen("config/config_global.php", "wb");
		fwrite($fp, $content);
		fclose($fp);
			
		@rename(''.$temp_file.'.php', ''.$xadmin_file.'.php');
		$bodytext .= "<tr><td colspan=\"2\">"._CONF_FILE.":</td><td><font color=\"green\">"._OK."</font></td></tr>";
	} else {
		$title = ""._ERROR2."";
		head();
		echo "<br><br><center>"._GOBACK."</center>";
		foot();
		exit;
	}
	head();
	echo "<table align=\"center\" border=\"0\" cellspacing=\"0\" cellpadding=\"3\">".$bodytext."</table>"
	."<form action=\"".$xadmin_file.".php\" method=\"post\"><br><center>"._GOBACK." <input type=\"submit\" value=\""._ADMIN."\"></center></form>";
	foot();
}
$op = (isset($_REQUEST['op'])) ? $_REQUEST['op'] : "";
switch($op) {
	default:
	language();
	break;

	case "english":
	setcookie ("lang", "english", time() + 3600);
	Header("Location: setup.php?op=language&lang=1");
	break;

	case "german":
	setcookie ("lang", "german", time() + 3600);
	Header("Location: setup.php?op=language&lang=1");
	break;

	case "russian":
	setcookie ("lang", "russian", time() + 3600);
	Header("Location: setup.php?op=language&lang=1");
	break;

	case "license":
	license();
	break;

	case "config":
	config();
	break;

	case "save":
	save($setup, $xdbhost, $xdbuname, $xdbpass, $xdbname, $xadmin_file, $xprefix);
	break;
}
?>