# phpMyAdmin SQL Dump
# version 2.5.6
# http://www.phpmyadmin.net
#
# Host: localhost
# Erstellungszeit: 22. Juni 2005 um 00:38
# Server Version: 4.0.18
# PHP-Version: 4.3.6

# --------------------------------------------------------
# Datenbank: `slaed system`
# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `slaed_album_categories`
#

CREATE TABLE `slaed_album_categories` (
  `gallid` int(3) NOT NULL auto_increment,
  `gallname` varchar(30) NOT NULL default '',
  `gallimg` varchar(50) NOT NULL default '',
  `galloc` longtext,
  `description` text NOT NULL,
  `parent` int(3) NOT NULL default '-1',
  `visible` tinyint(3) unsigned NOT NULL default '0',
  `template` int(10) unsigned NOT NULL default '2',
  `thumbwidth` int(2) unsigned NOT NULL default '70',
  `numcol` tinyint(3) unsigned NOT NULL default '3',
  `total` int(10) unsigned NOT NULL default '0',
  `lastadd` date NOT NULL default '0000-00-00',
  PRIMARY KEY  (`gallid`),
  KEY `gallid` (`gallid`)
) TYPE=MyISAM;

# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `slaed_album_comments`
#

CREATE TABLE `slaed_album_comments` (
  `cid` int(11) NOT NULL auto_increment,
  `pid` int(4) NOT NULL default '0',
  `comment` text NOT NULL,
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `name` varchar(255) default NULL,
  `member` int(1) NOT NULL default '0',
  PRIMARY KEY  (`cid`)
) TYPE=MyISAM;

# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `slaed_album_media_class`
#

CREATE TABLE `slaed_album_media_class` (
  `id` int(2) NOT NULL default '0',
  `class` varchar(10) NOT NULL default '',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `id` (`id`)
) TYPE=MyISAM;

#
# Daten fr Tabelle `slaed_album_media_class`
#

INSERT INTO `slaed_album_media_class` (`id`, `class`) VALUES (1, 'Image');
INSERT INTO `slaed_album_media_class` (`id`, `class`) VALUES (2, 'Audio');
INSERT INTO `slaed_album_media_class` (`id`, `class`) VALUES (3, 'Video');

# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `slaed_album_media_types`
#

CREATE TABLE `slaed_album_media_types` (
  `extension` varchar(10) NOT NULL default '',
  `description` text NOT NULL,
  `filetype` varchar(20) NOT NULL default '',
  `displaytag` text NOT NULL,
  `thumbnail` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`extension`)
) TYPE=MyISAM;

#
# Daten fr Tabelle `slaed_album_media_types`
#

INSERT INTO `slaed_album_media_types` (`extension`, `description`, `filetype`, `displaytag`, `thumbnail`) VALUES ('bmp', 'Image/BMP', '1', '<img src="<:FILENAME:>" border="0" alt="<:DESCRIPTION:>">', 'GIF.gif');
INSERT INTO `slaed_album_media_types` (`extension`, `description`, `filetype`, `displaytag`, `thumbnail`) VALUES ('gif', 'Image/GIF', '1', '<img src="<:FILENAME:>" border="0" width="<:WIDTH:>" height="<:HEIGHT:>" alt="<:DESCRIPTION:>">', 'GIF.gif');
INSERT INTO `slaed_album_media_types` (`extension`, `description`, `filetype`, `displaytag`, `thumbnail`) VALUES ('jpg', 'Image/JPG', '1', '<img src="<:FILENAME:>" border="0" width="<:WIDTH:>" height="<:HEIGHT:>" alt="<:DESCRIPTION:>">', 'JPG.gif');
INSERT INTO `slaed_album_media_types` (`extension`, `description`, `filetype`, `displaytag`, `thumbnail`) VALUES ('png', 'Image/PNG', '1', '<img src="<:FILENAME:>" border="0" width="<:WIDTH:>" height="<:HEIGHT:>" alt="<:DESCRIPTION:>">', 'PNG.gif');
INSERT INTO `slaed_album_media_types` (`extension`, `description`, `filetype`, `displaytag`, `thumbnail`) VALUES ('mov', 'Video/Quicktime', '3', '<embed controller="true" width="<:WIDTH:>" height="<:HEIGHT:>" src="<:FILENAME:>" border="0" pluginspage="http://www.apple.com/quicktime/download/indext.html"></embed>', 'MOV.gif');
INSERT INTO `slaed_album_media_types` (`extension`, `description`, `filetype`, `displaytag`, `thumbnail`) VALUES ('avi', 'Video/AVI', '3', '<embed src="<:FILENAME:>" border="0" width="<:WIDTH:>" height="<:HEIGHT:>" type="application/x-mplayer2"></embed>', 'AVI.gif');
INSERT INTO `slaed_album_media_types` (`extension`, `description`, `filetype`, `displaytag`, `thumbnail`) VALUES ('mpg', 'Video/MPEG', '3', '<embed src="<:FILENAME:>" border="0" width="<:WIDTH:>" height="<:HEIGHT:>" type="application/x-mplayer2"></embed>', 'MPG.gif');
INSERT INTO `slaed_album_media_types` (`extension`, `description`, `filetype`, `displaytag`, `thumbnail`) VALUES ('mp3', 'Audio/MP3', '2', '<embed controller="true" width="200" height="20" src="<:FILENAME:>" border="0" pluginspage="http://www.apple.com/quicktime/download/indext.html"></embed>', 'MP3.gif');
INSERT INTO `slaed_album_media_types` (`extension`, `description`, `filetype`, `displaytag`, `thumbnail`) VALUES ('mid', 'Audio/MIDI', '2', '<embed src="<:FILENAME:>" type="audio/midi" hidden="false" autostart="true" loop="true" height="20" width="200"></embed>', 'MID.gif');
INSERT INTO `slaed_album_media_types` (`extension`, `description`, `filetype`, `displaytag`, `thumbnail`) VALUES ('swf', 'Video/Flash', '3', '<embed src="<:FILENAME:>" pluginspage="http://www.macromedia.com/shockwave/download/index.cgi?P1_Prod_Version=ShockwaveFlash" type="application/x-shockwave-flash" width="<:WIDTH:>" height="<:HEIGHT:>" play="true" loop="true" quality="high" scale="showall" menu="true"></embed>', 'SWF.gif');
INSERT INTO `slaed_album_media_types` (`extension`, `description`, `filetype`, `displaytag`, `thumbnail`) VALUES ('rm', 'Video/RealMedia', '3', '<OBJECT height="<:HEIGHT:>">\r\n<PARAM NAME="CONTROLS" VALUE="ImageWindow">\r\n<PARAM NAME="AUTOSTART" Value="true">\r\n<PARAM NAME="SRC" VALUE="<:FILENAME:>">\r\n<embed height="<:HEIGHT:>" width="<:WIDTH:>" controls="ImageWindow" src="<:FILENAME:>?embed" type="audio/x-pn-realaudio-plugin" autostart="true" nolabels="0" autogotourl="-1"></OBJECT>', 'REAL.gif');

# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `slaed_album_pictures`
#

CREATE TABLE `slaed_album_pictures` (
  `pid` int(10) unsigned NOT NULL auto_increment,
  `gid` int(3) NOT NULL default '0',
  `img` varchar(255) NOT NULL default '',
  `counter` int(10) unsigned NOT NULL default '0',
  `submitter` varchar(24) NOT NULL default 'Webmaster',
  `date` datetime default NULL,
  `name` varchar(255) NOT NULL default '',
  `description` text NOT NULL,
  `votes` int(10) unsigned NOT NULL default '0',
  `rate` float NOT NULL default '0',
  `extension` varchar(10) NOT NULL default 'image',
  `width` smallint(5) unsigned NOT NULL default '0',
  `height` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`pid`),
  KEY `pid` (`pid`)
) TYPE=MyISAM;

# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `slaed_album_pictures_newpicture`
#

CREATE TABLE `slaed_album_pictures_newpicture` (
  `pid` int(10) unsigned NOT NULL auto_increment,
  `gid` int(3) NOT NULL default '0',
  `img` varchar(255) NOT NULL default '',
  `counter` int(10) unsigned NOT NULL default '0',
  `submitter` varchar(24) NOT NULL default 'Webmaster',
  `date` datetime default NULL,
  `name` varchar(255) NOT NULL default '',
  `description` text NOT NULL,
  `votes` int(10) unsigned NOT NULL default '0',
  `rate` float NOT NULL default '0',
  `extension` varchar(10) NOT NULL default 'image',
  `width` smallint(5) unsigned NOT NULL default '0',
  `height` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`pid`),
  KEY `pid` (`pid`)
) TYPE=MyISAM;

# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `slaed_album_rate_check`
#

CREATE TABLE `slaed_album_rate_check` (
  `ip` varchar(20) NOT NULL default '',
  `time` varchar(14) NOT NULL default '',
  `pid` int(10) unsigned NOT NULL default '0'
) TYPE=MyISAM;

# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `slaed_album_template_types`
#

CREATE TABLE `slaed_album_template_types` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `title` varchar(255) NOT NULL default '',
  `type` tinyint(3) unsigned NOT NULL default '2',
  `templateCategory` longtext NOT NULL,
  `templatePictures` longtext NOT NULL,
  `templateCSS` longtext,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;

#
# Daten fr Tabelle `slaed_album_template_types`
#

INSERT INTO `slaed_album_template_types` (`id`, `title`, `type`, `templateCategory`, `templatePictures`, `templateCSS`) VALUES (1, 'Default Main Page Template', 1, '<table align="center">\r\n<tr>\r\n        <td colspan="2">\r\n                <:GALLNAME:>\r\n        </td>\r\n</tr>\r\n<tr>\r\n        <td>\r\n                <:IMAGE:>\r\n        </td>\r\n        <td valign="top" align="left">\r\n                <:DESCRIPTION:>\r\n        </td>\r\n</tr>\r\n</table>', '2', '.common_text_black {text-color:#000000}\r\n.common_text_white {text-color:#ffffff}');
INSERT INTO `slaed_album_template_types` (`id`, `title`, `type`, `templateCategory`, `templatePictures`, `templateCSS`) VALUES (2, 'Default', 2, '<table border="0" cellpadding="0" cellspacing="0">\r\n<tr>\r\n        <td>\r\n                <:IMAGE:>\r\n        </td>\r\n        <td valign="top">\r\n                <p>\r\n                                <table>\r\n                                <tr>\r\n                                        <td align="center">\r\n                                                <:DATE:>\r\n                                        </td>\r\n                                        <td align="center">\r\n                                                <:RATE:>\r\n                                        </td>\r\n                                        <td align="center">\r\n                                                <:HITS:>\r\n                                        </td>\r\n                                        <td align="center">\r\n                                                <:NEW:>\r\n                                        </td>\r\n                                </tr>\r\n                                </table>\r\n                </p>\r\n                <p>\r\n                                <:DESCRIPTION:>\r\n                </p>\r\n                <p>\r\n                                <:NBCOMMENTS:> <br> <:FORMAT:> <br> <:SIZE:>\r\n                </p>\r\n        </td>\r\n</tr>\r\n</table>', '<table>\r\n<tr>\r\n        <td valign="top" align="center">\r\n                <:NAMESIZE:>\r\n                <br><br>\r\n                <TABLE CellPadding="0" CellSpacing="0">\r\n                <TR>\r\n                        <TD valign="top">\r\n                                <:SUBMITTER:>\r\n                                <:DATE:>\r\n                                <:HITS:>\r\n                                <:RATE:>\r\n                        </TD>\r\n                </TR>\r\n                </table><br>\r\n                <:RATINGBAR:><br>\r\n                <:POSTCARD:><br>\r\n                <:DOWNLOAD:><br>\r\n                <:PRINT:>\r\n        </td>\r\n        <td width="80%" align="center">\r\n                <:IMAGE:>\r\n        </td>\r\n</tr>\r\n<tr>\r\n        <td colspan="2"><:DESCRIPTION:></td>\r\n</tr>\r\n<tr>\r\n        <td colspan="2">\r\n                <:COMMENTS:>\r\n        </td>\r\n</tr>\r\n</table>', '.common_text_black {text-color:#000000}\r\n.common_text_white {text-color:#ffffff}');

# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `slaed_internet_radio`
#

CREATE TABLE `slaed_internet_radio` (
  `radio_id` int(10) unsigned NOT NULL auto_increment,
  `radio_name` varchar(20) NOT NULL default '',
  `radio_stream` varchar(255) NOT NULL default '',
  `radio_url` varchar(255) NOT NULL default '',
  `radio_picture` varchar(50) NOT NULL default '',
  `radio_language` varchar(30) NOT NULL default '',
  PRIMARY KEY  (`radio_id`)
) TYPE=MyISAM;

#
# Daten fr Tabelle `slaed_internet_radio`
#

INSERT INTO `slaed_internet_radio` (`radio_id`, `radio_name`, `radio_stream`, `radio_url`, `radio_picture`, `radio_language`) VALUES (5, '', 'http://www.radiomayak.ru/air/newair.asx', 'http://www.radiomayak.ru', 'majak.gif', '');
INSERT INTO `slaed_internet_radio` (`radio_id`, `radio_name`, `radio_stream`, `radio_url`, `radio_picture`, `radio_language`) VALUES (8, 'Rock Radio 101', 'http://www.101.ru/101.asx', 'http://www.101.ru', 'rockradio101.gif', '');
INSERT INTO `slaed_internet_radio` (`radio_id`, `radio_name`, `radio_stream`, `radio_url`, `radio_picture`, `radio_language`) VALUES (2, ' ', 'http://radio.wplus.net/radio/rbalt.asx', 'http://www.rbalt.spb.ru', 'radiobaltika.gif', '');
INSERT INTO `slaed_internet_radio` (`radio_id`, `radio_name`, `radio_stream`, `radio_url`, `radio_picture`, `radio_language`) VALUES (6, ' ', 'mms://217.16.18.76/32K', 'http://www.rusradio.ru', 'russkoeradio.gif', '');
INSERT INTO `slaed_internet_radio` (`radio_id`, `radio_name`, `radio_stream`, `radio_url`, `radio_picture`, `radio_language`) VALUES (7, '', 'http://62.118.252.135/autoradio', 'http://www.avtoradio.ru', 'avtoradio.gif', '');
INSERT INTO `slaed_internet_radio` (`radio_id`, `radio_name`, `radio_stream`, `radio_url`, `radio_picture`, `radio_language`) VALUES (9, 'Russian Songs 101', 'http://www.101.ru/rus.asx', 'http://www.101.ru', 'russiansongs101.gif', '');
INSERT INTO `slaed_internet_radio` (`radio_id`, `radio_name`, `radio_stream`, `radio_url`, `radio_picture`, `radio_language`) VALUES (10, 'Dance 101', 'http://www.101.ru/dance.asx', 'http://www.101.ru', 'dance101.gif', '');
INSERT INTO `slaed_internet_radio` (`radio_id`, `radio_name`, `radio_stream`, `radio_url`, `radio_picture`, `radio_language`) VALUES (11, 'SR ', 'http://www.specialradio.ru/server.asx', 'http://www.specialradio.ru', 'spezialnoeradio.gif', '');
INSERT INTO `slaed_internet_radio` (`radio_id`, `radio_name`, `radio_stream`, `radio_url`, `radio_picture`, `radio_language`) VALUES (12, 'SR ', 'http://www.specialradio.ru/2_64k.asx', 'http://www.specialradio.ru', 'spezialnoeradio.gif', '');
INSERT INTO `slaed_internet_radio` (`radio_id`, `radio_name`, `radio_stream`, `radio_url`, `radio_picture`, `radio_language`) VALUES (13, 'SR  ', 'http://www.specialradio.ru/3_64k.asx', 'http://www.specialradio.ru', 'spezialnoeradio.gif', '');
INSERT INTO `slaed_internet_radio` (`radio_id`, `radio_name`, `radio_stream`, `radio_url`, `radio_picture`, `radio_language`) VALUES (14, 'SR  ', 'http://www.specialradio.ru/5_64k.asx', 'http://www.specialradio.ru', 'spezialnoeradio.gif', '');
INSERT INTO `slaed_internet_radio` (`radio_id`, `radio_name`, `radio_stream`, `radio_url`, `radio_picture`, `radio_language`) VALUES (15, 'SR  ', 'http://www.specialradio.ru/6_64k.asx', 'http://www.specialradio.ru', 'spezialnoeradio.gif', '');
INSERT INTO `slaed_internet_radio` (`radio_id`, `radio_name`, `radio_stream`, `radio_url`, `radio_picture`, `radio_language`) VALUES (16, 'SR  ', 'http://www.specialradio.ru/7_64k.asx', 'http://www.specialradio.ru', 'spezialnoeradio.gif', '');
INSERT INTO `slaed_internet_radio` (`radio_id`, `radio_name`, `radio_stream`, `radio_url`, `radio_picture`, `radio_language`) VALUES (17, 'SR ', 'http://www.specialradio.ru/8_64k.asx', 'http://www.specialradio.ru', 'spezialnoeradio.gif', '');
INSERT INTO `slaed_internet_radio` (`radio_id`, `radio_name`, `radio_stream`, `radio_url`, `radio_picture`, `radio_language`) VALUES (18, 'SR  ', 'http://www.specialradio.ru/12_64k.asx', 'http://www.specialradio.ru', 'spezialnoeradio.gif', '');
INSERT INTO `slaed_internet_radio` (`radio_id`, `radio_name`, `radio_stream`, `radio_url`, `radio_picture`, `radio_language`) VALUES (19, 'SR ', 'http://www.specialradio.ru/13_64k.asx', 'http://www.specialradio.ru', 'spezialnoeradio.gif', '');
INSERT INTO `slaed_internet_radio` (`radio_id`, `radio_name`, `radio_stream`, `radio_url`, `radio_picture`, `radio_language`) VALUES (20, ' ', 'http://wm3.rbcmp3.com/nashe3', 'http://www.nashe.ru', 'nascheradio.gif', '');
INSERT INTO `slaed_internet_radio` (`radio_id`, `radio_name`, `radio_stream`, `radio_url`, `radio_picture`, `radio_language`) VALUES (21, ' ', 'mms://stream.rfn.ru/radiorussia', 'http://www.radiorus.ru', 'radiorossii.gif', '');
INSERT INTO `slaed_internet_radio` (`radio_id`, `radio_name`, `radio_stream`, `radio_url`, `radio_picture`, `radio_language`) VALUES (22, ' ', 'http://radio.wplus.net/radio/rhit.asx', 'http://www.radiohit.ru', 'radiochit.gif', '');
INSERT INTO `slaed_internet_radio` (`radio_id`, `radio_name`, `radio_stream`, `radio_url`, `radio_picture`, `radio_language`) VALUES (23, ' FM', 'mms://217.16.18.76/Dinamit_FM-32K', 'http://www.dinamitfm.ru', 'dinamitfm.gif', '');
INSERT INTO `slaed_internet_radio` (`radio_id`, `radio_name`, `radio_stream`, `radio_url`, `radio_picture`, `radio_language`) VALUES (25, 'Maxima-', 'http://wms.tochka.ru/MaximaRadio', 'http://netradio.tochka.ru', 'netradio.gif', '');
INSERT INTO `slaed_internet_radio` (`radio_id`, `radio_name`, `radio_stream`, `radio_url`, `radio_picture`, `radio_language`) VALUES (26, ' Pop', 'http://wms.tochka.ru/NetRadio-Foreign', 'http://netradio.tochka.ru', 'netradio.gif', '');
INSERT INTO `slaed_internet_radio` (`radio_id`, `radio_name`, `radio_stream`, `radio_url`, `radio_picture`, `radio_language`) VALUES (27, ' ', 'http://wms.tochka.ru/NetRadio-RusPop', 'http://netradio.tochka.ru', 'netradio.gif', '');
INSERT INTO `slaed_internet_radio` (`radio_id`, `radio_name`, `radio_stream`, `radio_url`, `radio_picture`, `radio_language`) VALUES (28, ' ', 'http://wms.tochka.ru/NetRadio-RusRock', 'http://netradio.tochka.ru', 'netradio.gif', '');
INSERT INTO `slaed_internet_radio` (`radio_id`, `radio_name`, `radio_stream`, `radio_url`, `radio_picture`, `radio_language`) VALUES (29, ' ', 'http://wms.tochka.ru/NetRadio-RusOld', 'http://netradio.tochka.ru', 'netradio.gif', '');

# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `slaed_internet_radio_settings`
#

CREATE TABLE `slaed_internet_radio_settings` (
  `modulename` varchar(30) NOT NULL default '',
  `auto_start` tinyint(1) NOT NULL default '0',
  `picture` tinyint(1) NOT NULL default '0',
  `picture_dir` varchar(50) NOT NULL default '',
  `defpicture` tinyint(1) NOT NULL default '0',
  `nopicture_name` varchar(50) NOT NULL default '',
  `radiovert` mediumint(3) NOT NULL default '212',
  `radiohor` mediumint(3) NOT NULL default '264',
  `pop_block` tinyint(1) NOT NULL default '1',
  `pop_mod` tinyint(1) NOT NULL default '1'
) TYPE=MyISAM;

#
# Daten fr Tabelle `slaed_internet_radio_settings`
#

INSERT INTO `slaed_internet_radio_settings` (`modulename`, `auto_start`, `picture`, `picture_dir`, `defpicture`, `nopicture_name`, `radiovert`, `radiohor`, `pop_block`, `pop_mod`) VALUES ('Internet_Radio', 0, 1, 'modules/Internet_Radio/images', 1, 'internet_radio.gif', 50, 200, 2, 2);

# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `slaed_jokes`
#

CREATE TABLE `slaed_jokes` (
  `jokeid` int(11) NOT NULL auto_increment,
  `author` varchar(100) NOT NULL default '',
  `email` varchar(100) NOT NULL default '',
  `date` datetime default NULL,
  `name` varchar(100) NOT NULL default '',
  `cat` varchar(10) NOT NULL default '',
  `joke` text NOT NULL,
  `rating` varchar(100) NOT NULL default '0',
  `ratingtot` varchar(100) NOT NULL default '0',
  `ratings` varchar(5) NOT NULL default '',
  UNIQUE KEY `id` (`jokeid`)
) TYPE=MyISAM;

# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `slaed_jokes_categories`
#

CREATE TABLE `slaed_jokes_categories` (
  `jokecid` int(11) NOT NULL auto_increment,
  `catname` varchar(150) NOT NULL default '',
  UNIQUE KEY `id` (`jokecid`)
) TYPE=MyISAM;

#
# Daten fr Tabelle `slaed_jokes_categories`
#

INSERT INTO `slaed_jokes_categories` (`jokecid`, `catname`) VALUES (1, '  ');
INSERT INTO `slaed_jokes_categories` (`jokecid`, `catname`) VALUES (2, '');
INSERT INTO `slaed_jokes_categories` (`jokecid`, `catname`) VALUES (3, ' ');
INSERT INTO `slaed_jokes_categories` (`jokecid`, `catname`) VALUES (4, ' ');
INSERT INTO `slaed_jokes_categories` (`jokecid`, `catname`) VALUES (5, '  ');
INSERT INTO `slaed_jokes_categories` (`jokecid`, `catname`) VALUES (6, ' ');
INSERT INTO `slaed_jokes_categories` (`jokecid`, `catname`) VALUES (7, ' ');
INSERT INTO `slaed_jokes_categories` (`jokecid`, `catname`) VALUES (8, ' ');
INSERT INTO `slaed_jokes_categories` (`jokecid`, `catname`) VALUES (9, '  ');
INSERT INTO `slaed_jokes_categories` (`jokecid`, `catname`) VALUES (10, ' ');
INSERT INTO `slaed_jokes_categories` (`jokecid`, `catname`) VALUES (11, '');
INSERT INTO `slaed_jokes_categories` (`jokecid`, `catname`) VALUES (12, '');
INSERT INTO `slaed_jokes_categories` (`jokecid`, `catname`) VALUES (13, ' ');
INSERT INTO `slaed_jokes_categories` (`jokecid`, `catname`) VALUES (14, '');
INSERT INTO `slaed_jokes_categories` (`jokecid`, `catname`) VALUES (15, '');
INSERT INTO `slaed_jokes_categories` (`jokecid`, `catname`) VALUES (16, ' ');
INSERT INTO `slaed_jokes_categories` (`jokecid`, `catname`) VALUES (17, '');
INSERT INTO `slaed_jokes_categories` (`jokecid`, `catname`) VALUES (18, ' ');
INSERT INTO `slaed_jokes_categories` (`jokecid`, `catname`) VALUES (24, ' ');
INSERT INTO `slaed_jokes_categories` (`jokecid`, `catname`) VALUES (22, '');
INSERT INTO `slaed_jokes_categories` (`jokecid`, `catname`) VALUES (23, '  ');

# --------------------------------------------------------

#
# Tabellenstruktur fr Tabelle `slaed_jokes_unvalid`
#

CREATE TABLE `slaed_jokes_unvalid` (
  `jokeuid` int(11) NOT NULL auto_increment,
  `author` varchar(100) NOT NULL default '',
  `email` varchar(100) NOT NULL default '',
  `name` varchar(100) NOT NULL default '',
  `cat` varchar(10) NOT NULL default '',
  `joke` text NOT NULL,
  UNIQUE KEY `id` (`jokeuid`)
) TYPE=MyISAM;